//+------------------------------------------------------------------+
//|                                             Keltner Channels.mq4 |
//|                                                  Coded by Gilani |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 PaleVioletRed


//double upper[], middle[], lower[];
extern int period = 7;
extern double  NumATRs  =0.75;

extern bool   alertsOn          = true;
extern bool   alertsOnCurrent   = False;
extern double alertsLevel       = 5;
extern bool   alertsMessage     = true;
extern bool   alertsSound       = True;
extern bool   alertsEmail       = false;
datetime prevtime = 0;

//---- buffers
double upper[];
double middle[];
double lower[];
double trend[];




/*
extern int SoundAlert  =    1; // 0 = disabled
extern int PopUpAlert = 1;
extern string BuySoundFile = "alert.wav";
extern string SellSoundFile = "alert2.wav";
extern int EmailAlert  =    1;
datetime prevtime = 0;
*/

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(1,upper);
   SetIndexBuffer(2,middle);
   SetIndexBuffer(3,lower);
   SetIndexBuffer(0,trend);
   SetIndexLabel(0,"trend-KC");
   
   
   
   
   IndicatorShortName("RK-KeltnerChannels-Alert("+period+")"); 
   SetIndexLabel(0,"KC-upper");
   SetIndexLabel(1,"Kc-middle");
   SetIndexLabel(2,"KC-lower");     
return(0);
}
int deinit(){return(0);}
int start() 
{
   int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
   double avg;
   //
   //
   //    do it from left to right and that way you will control
   //    the cases when price is equal to either of chanels (the 
   //    trend[x] = trend[x+1] covers the case when close == channel band)
   //
   //
   
   for(int x=limit; x>=0; x--) 
   {
      middle[x] = iMA(NULL, 0, period, 0, MODE_SMA, PRICE_CLOSE, x);
      avg  = findAvg(period, x);
      upper[x] = middle[x] + (avg*NumATRs);
      lower[x] = middle[x] - (avg*NumATRs);
      trend[x] = trend[x+1];
       if (Close[x] > upper[x])  trend[x] =  1;
       if (Close[x] < lower[x])  trend[x] = -1;
   }
   manageAlerts();  
   return(0);
}
//+------------------------------------------------------------------+
   
 void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //if ((Close [whichBar]>= lower[whichBar]) && (Close[whichBar] <= upper[whichBar])) //{ prevtime = 0;
       
      if ((Close[whichBar] > upper[whichBar]) && (prevtime != Time[0]))doAlert(whichBar,"up"  ,1);
      //if (trendsBuffer[whichBar] ==  1) doAlert(whichBar,"up"  ,valuesBuffer[whichBar]);
     // if (trendsBuffer[whichBar] == -1) doAlert(whichBar,"down",valuesBuffer[whichBar]);
      if ((Close[whichBar] < lower[whichBar]) && (prevtime != Time[0]))doAlert(whichBar,"down",-1);
   
   }
}
void doAlert(int forBar, string doWhat,double value)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       message =  StringConcatenate(Symbol()," tf-",(Period())," at ",
       TimeToStr(TimeLocal(),TIME_SECONDS)," RK-KC Alert "+"  Bid -"+DoubleToStr(Bid,Digits)+"  Ask -"+DoubleToStr(Ask,Digits)+"  "
       +DoubleToStr(value,2)+" KC Breakout-",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Keltner breakout "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}
//-------------------------------------------

double findAvg(int period, int shift) {
      double sum=0;
      for (int x=shift;x<(shift+period);x++) {     
         sum += High[x]-Low[x];
      }
      sum = sum/period;
      return (sum);
   }